#!/bin/sh

DIFF_LEN=$( cd /usr/src ; svn diff sys/net/if_lagg.c | wc -l )

log_and_run()
{
    cmd="$@"
    logger "${cmd}"
    ${cmd}
    sleep 1
}


if [ ${DIFF_LEN} -eq 0 ] ; then
    log_and_run ifconfig lagg0 create
    # Feb  9 21:47:01 fbsd-X root: ifconfig lagg0 create
    log_and_run ifconfig lagg0 laggport em1
    # Feb  9 21:47:02 fbsd-X root: ifconfig lagg0 laggport em1
    # Feb  9 21:47:02 fbsd-X kernel: lock order reversal:
    # Feb  9 21:47:02 fbsd-X kernel: 1st 0xfffff80004950a08 if_lagg rmlock (if_lagg rmlock) @ /usr/src/sys/modules/if_lagg/../../net/if_lagg.c:1414
    # Feb  9 21:47:02 fbsd-X kernel: 2nd 0xfffff80004cb7190 if_addr_lock (if_addr_lock) @ /usr/src/sys/modules/if_lagg/../../net/if_lagg.c:1518
    # Feb  9 21:47:02 fbsd-X kernel: KDB: stack backtrace:
    # Feb  9 21:47:02 fbsd-X kernel: db_trace_self_wrapper() at db_trace_self_wrapper+0x2b/frame 0xfffffe0120a276f0
    # Feb  9 21:47:02 fbsd-X kernel: witness_checkorder() at witness_checkorder+0xe45/frame 0xfffffe0120a27780
    # Feb  9 21:47:02 fbsd-X kernel: _rw_wlock_cookie() at _rw_wlock_cookie+0x71/frame 0xfffffe0120a277c0
    # Feb  9 21:47:02 fbsd-X kernel: lagg_ether_cmdmulti() at lagg_ether_cmdmulti+0x5c/frame 0xfffffe0120a27800
    # Feb  9 21:47:02 fbsd-X kernel: lagg_ioctl() at lagg_ioctl+0x10fe/frame 0xfffffe0120a278e0
    # Feb  9 21:47:02 fbsd-X kernel: ifioctl() at ifioctl+0xb46/frame 0xfffffe0120a279a0
    # Feb  9 21:47:02 fbsd-X kernel: kern_ioctl() at kern_ioctl+0x2c0/frame 0xfffffe0120a27a00
    # Feb  9 21:47:02 fbsd-X kernel: sys_ioctl() at sys_ioctl+0x153/frame 0xfffffe0120a27ae0
    # Feb  9 21:47:02 fbsd-X kernel: amd64_syscall() at amd64_syscall+0x27f/frame 0xfffffe0120a27bf0
    # Feb  9 21:47:02 fbsd-X kernel: Xfast_syscall() at Xfast_syscall+0xfb/frame 0xfffffe0120a27bf0
    # Feb  9 21:47:02 fbsd-X kernel: --- syscall (54, FreeBSD ELF64, sys_ioctl), rip = 0x8011e1c9a, rsp = 0x7fffffffe218, rbp = 0x7fffffffe290 ---
    # Feb  9 21:47:02 fbsd-X kernel: lagg0: link state changed to UP
    log_and_run ifconfig lagg0 laggport em2
    # Feb  9 21:47:03 fbsd-X root: ifconfig lagg0 laggport em2

    log_and_run ifconfig lagg0 -laggport em2
    # Feb  9 21:47:04 fbsd-X root: ifconfig lagg0 -laggport em2
    log_and_run ifconfig lagg0 -laggport em1
    # Feb  9 21:47:05 fbsd-X root: ifconfig lagg0 -laggport em1
    # Feb  9 21:47:05 fbsd-X kernel: lagg0: link state changed to DOWN
    log_and_run ifconfig em1 mtu 1500
    # Feb  9 21:47:06 fbsd-X root: ifconfig em1 mtu 1500
    log_and_run ifconfig em2 mtu 1500
    # Feb  9 21:47:07 fbsd-X root: ifconfig em2 mtu 1500
    log_and_run ifconfig lagg0 laggport em1
    # Feb  9 21:47:08 fbsd-X root: ifconfig lagg0 laggport em1
    # Feb  9 21:47:08 fbsd-X kernel: lagg0: link state changed to UP
    log_and_run ifconfig lagg0 laggport em2
    # Feb  9 21:47:09 fbsd-X root: ifconfig lagg0 laggport em2

    log_and_run ifconfig lagg0 -laggport em2
    # Feb  9 21:47:10 fbsd-X root: ifconfig lagg0 -laggport em2
    log_and_run ifconfig lagg0 -laggport em1
    # Feb  9 21:47:11 fbsd-X root: ifconfig lagg0 -laggport em1
    # Feb  9 21:47:11 fbsd-X kernel: lagg0: link state changed to DOWN
    log_and_run ifconfig em1 mtu 9000
    # Feb  9 21:47:13 fbsd-X root: ifconfig em1 mtu 9000
    log_and_run ifconfig em2 mtu 9000
    # Feb  9 21:47:14 fbsd-X root: ifconfig em2 mtu 9000
    log_and_run ifconfig lagg0 laggport em1
    # Feb  9 21:47:15 fbsd-X root: ifconfig lagg0 laggport em1
    # Feb  9 21:47:15 fbsd-X kernel: lagg0: link state changed to UP
    log_and_run ifconfig lagg0 laggport em2
    # Feb  9 21:47:16 fbsd-X root: ifconfig lagg0 laggport em2

    log_and_run ifconfig lagg0 -laggport em2
    # Feb  9 21:47:17 fbsd-X root: ifconfig lagg0 -laggport em2
    log_and_run ifconfig lagg0 -laggport em1
    # Feb  9 21:47:18 fbsd-X root: ifconfig lagg0 -laggport em1
    # Feb  9 21:47:18 fbsd-X kernel: lagg0: link state changed to DOWN
    log_and_run ifconfig em1 mtu 1500
    # Feb  9 21:47:19 fbsd-X root: ifconfig em1 mtu 1500
    log_and_run ifconfig em2 mtu 1500
    # Feb  9 21:47:20 fbsd-X root: ifconfig em2 mtu 1500
    log_and_run ifconfig lagg0 laggport em1
    # Feb  9 21:47:21 fbsd-X root: ifconfig lagg0 laggport em1
    # Feb  9 21:47:21 fbsd-X kernel: lagg0: link state changed to UP
    log_and_run ifconfig lagg0 laggport em2
    # Feb  9 21:47:22 fbsd-X root: ifconfig lagg0 laggport em2

    log_and_run ifconfig lagg0 -laggport em2
    # Feb  9 21:47:23 fbsd-X root: ifconfig lagg0 -laggport em2
    log_and_run ifconfig lagg0 -laggport em1
    # Feb  9 21:47:24 fbsd-X root: ifconfig lagg0 -laggport em1
    # Feb  9 21:47:24 fbsd-X kernel: lagg0: link state changed to DOWN
    log_and_run ifconfig lagg0 destroy
    # Feb  9 21:47:25 fbsd-X root: ifconfig lagg0 destroy
else
    log_and_run ifconfig lagg0 create
    # Feb  9 22:18:26 fbsd-X root: ifconfig lagg0 create
    log_and_run ifconfig lagg0 laggport em1
    # Feb  9 22:18:27 fbsd-X root: ifconfig lagg0 laggport em1
    # Feb  9 22:18:27 fbsd-X kernel: lock order reversal:
    # Feb  9 22:18:27 fbsd-X kernel: 1st 0xfffff80004c9ba08 if_lagg rmlock (if_lagg rmlock) @ /usr/src/sys/modules/if_lagg/../../net/if_lagg.c:1415
    # Feb  9 22:18:27 fbsd-X kernel: 2nd 0xfffff80004c4d990 if_addr_lock (if_addr_lock) @ /usr/src/sys/modules/if_lagg/../../net/if_lagg.c:1521
    # Feb  9 22:18:27 fbsd-X kernel: KDB: stack backtrace:
    # Feb  9 22:18:27 fbsd-X kernel: db_trace_self_wrapper() at db_trace_self_wrapper+0x2b/frame 0xfffffe0120a36690
    # Feb  9 22:18:27 fbsd-X kernel: witness_checkorder() at witness_checkorder+0xe45/frame 0xfffffe0120a36720
    # Feb  9 22:18:27 fbsd-X kernel: _rw_wlock_cookie() at _rw_wlock_cookie+0x71/frame 0xfffffe0120a36760
    # Feb  9 22:18:27 fbsd-X kernel: lagg_ether_cmdmulti() at lagg_ether_cmdmulti+0x5c/frame 0xfffffe0120a367a0
    # Feb  9 22:18:27 fbsd-X kernel: lagg_ioctl() at lagg_ioctl+0x131a/frame 0xfffffe0120a368e0
    # Feb  9 22:18:27 fbsd-X kernel: ifioctl() at ifioctl+0xb46/frame 0xfffffe0120a369a0
    # Feb  9 22:18:27 fbsd-X kernel: kern_ioctl() at kern_ioctl+0x2c0/frame 0xfffffe0120a36a00
    # Feb  9 22:18:27 fbsd-X kernel: sys_ioctl() at sys_ioctl+0x153/frame 0xfffffe0120a36ae0
    # Feb  9 22:18:27 fbsd-X kernel: amd64_syscall() at amd64_syscall+0x27f/frame 0xfffffe0120a36bf0
    # Feb  9 22:18:27 fbsd-X kernel: Xfast_syscall() at Xfast_syscall+0xfb/frame 0xfffffe0120a36bf0
    # Feb  9 22:18:27 fbsd-X kernel: --- syscall (54, FreeBSD ELF64, sys_ioctl), rip = 0x8011e1c9a, rsp = 0x7fffffffe218, rbp = 0x7fffffffe290 ---
    # Feb  9 22:18:27 fbsd-X kernel: lagg0: link state changed to UP
    log_and_run ifconfig lagg0 laggport em2
    # Feb  9 22:18:28 fbsd-X root: ifconfig lagg0 laggport em2
    log_and_run ifconfig lagg0 mtu 1500
    # Feb  9 22:18:29 fbsd-X root: ifconfig lagg0 mtu 1500
    log_and_run ifconfig lagg0 mtu 9000
    # Feb  9 22:18:30 fbsd-X root: ifconfig lagg0 mtu 9000
    # Feb  9 22:18:31 fbsd-X kernel: lock order reversal:
    # Feb  9 22:18:31 fbsd-X kernel: 1st 0xfffff80004c9ba08 if_lagg rmlock (if_lagg rmlock) @ /usr/src/sys/modules/if_lagg/../../net/if_lagg.c:1781
    # Feb  9 22:18:31 fbsd-X kernel: 2nd 0xfffffe0000d46748 em1 (EM Core Lock) @ /usr/src/sys/dev/e1000/if_lem.c:1035
    # Feb  9 22:18:31 fbsd-X kernel: KDB: stack backtrace:
    # Feb  9 22:18:31 fbsd-X kernel: db_trace_self_wrapper() at db_trace_self_wrapper+0x2b/frame 0xfffffe0120a0e680
    # Feb  9 22:18:31 fbsd-X kernel: witness_checkorder() at witness_checkorder+0xe45/frame 0xfffffe0120a0e710
    # Feb  9 22:18:31 fbsd-X kernel: __mtx_lock_flags() at __mtx_lock_flags+0xa8/frame 0xfffffe0120a0e760
    # Feb  9 22:18:31 fbsd-X kernel: lem_ioctl() at lem_ioctl+0x3e8/frame 0xfffffe0120a0e7a0
    # Feb  9 22:18:31 fbsd-X kernel: lagg_ioctl() at lagg_ioctl+0xb09/frame 0xfffffe0120a0e8e0
    # Feb  9 22:18:31 fbsd-X kernel: ifioctl() at ifioctl+0x102e/frame 0xfffffe0120a0e9a0
    # Feb  9 22:18:31 fbsd-X kernel: kern_ioctl() at kern_ioctl+0x2c0/frame 0xfffffe0120a0ea00
    # Feb  9 22:18:31 fbsd-X kernel: sys_ioctl() at sys_ioctl+0x153/frame 0xfffffe0120a0eae0
    # Feb  9 22:18:31 fbsd-X kernel: amd64_syscall() at amd64_syscall+0x27f/frame 0xfffffe0120a0ebf0
    # Feb  9 22:18:31 fbsd-X kernel: Xfast_syscall() at Xfast_syscall+0xfb/frame 0xfffffe0120a0ebf0
    # Feb  9 22:18:31 fbsd-X kernel: --- syscall (54, FreeBSD ELF64, sys_ioctl), rip = 0x8011e1c9a, rsp = 0x7fffffffe288, rbp = 0x7fffffffe2a0 ---
    log_and_run ifconfig lagg0 mtu 1500
    # Feb  9 22:18:31 fbsd-X root: ifconfig lagg0 mtu 1500
    log_and_run ifconfig lagg0 -laggport em2
    # Feb  9 22:18:33 fbsd-X root: ifconfig lagg0 -laggport em2
    log_and_run ifconfig lagg0 -laggport em1
    # Feb  9 22:18:34 fbsd-X root: ifconfig lagg0 -laggport em1
    # Feb  9 22:18:34 fbsd-X kernel: lagg0: link state changed to DOWN
    log_and_run ifconfig lagg0 destroy
    # Feb  9 22:18:35 fbsd-X root: ifconfig lagg0 destroy
fi
